////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   22:25:20 02/22/2017
// Design Name:   vgaProject
// Module Name:   
// Project Name:  vga_2
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: vgaProject
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////
module vgaProject(input clk,								// System clk
						input [3:0]r,							// input from switches
						input [3:0]g,
						input [3:0]b,
						output reg [3:0]red,					// display on VGA
						output reg [3:0]green,
						output reg [3:0]blue,
						output VS,								// Vertical sync obtained from vgaPulse Vertical
						output HS,								// Horizontal sync obtained from vgaPulse Horizontal
						output vFree,
						output hFree);


					
reg [3:0] free;
wire [10:0] x,y;

vgaPulse Horizontal(.clk(pixelClk),
						  .stage1(21'd96),					// See reference manual for values
						  .stage2(21'd144),
						  .stage3(21'd784),
						  .endStage(21'd800),
						  .syncPulse(HS),
						  .free(hFree),			// Can display on screen
						  .position(x)
						  );				// Instantiate module vgaPulse


vgaPulse Vertical(.clk(HS),	
						.stage1(21'd2),			// See reference manual for values
						.stage2(21'd35),
						.stage3(21'd515),
						.endStage(21'd525),
						.syncPulse(VS),
						.free(vFree),			// Can display on screen
						.position(y)
						);				// Instantiate module vgaPulse


clockDiv pixel(.clk(clk),
					.div(32'd4),			// We need 25Mhz but system clock runs at 100Mhz
					.out(pixelClk)			// clock at 25Mhz
					);			// Instantiate module clockDiv
					
					


always begin

free[0]=hFree&&vFree&&(x<500)&&(x>450)&&(y<450)&&(y>400);				// value of 'x' and 'hfree' obtained from vgaPulse Horizontal
free[1]=hFree&&vFree&&(x<500)&&(x>450)&&(y<450)&&(y>400);				// value of 'y' and 'vfree' obtained from vgaPulse Vertical
free[2]=hFree&&vFree&&(x<500)&&(x>450)&&(y<450)&&(y>400);
free[3]=hFree&&vFree&&(x<500)&&(x>450)&&(y<450)&&(y>400);

red=r&free;								// if free show red on VGA 
green=g&free;							// if free show green on VGA
blue=b&free;							// if free show blue on VGA

end
					
					
endmodule
